<?php
namespace EMS\PortalFuncionario\Geral\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Doctrine\ORM\EntityManager;

use EMS\PortalFuncionario\Geral\Services\ComunicadoService;

class ComunicadoController {

    public function __construct(EntityManager $entityManager, ComunicadoService $comunicadoService) {
        $this->entityManager        = $entityManager;
        $this->comunicadoService     = $comunicadoService;
    }

    public function getComunicados(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $params = $request->getParameters();
            $comunicados = $this->comunicadoService->getComunicados(
                $params['NRVINCULOM'],
                $params['NRORG']
            );
            $response->addDataSet(new DataSet('data', $comunicados));
        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }

    public function getComunicados_quantidade(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $params = $request->getParameters();
            $comunicados = $this->comunicadoService->getComunicados_quantidade(
                $params['NRVINCULOM'],
                $params['NRORG']
            );
            $response->addDataSet(new DataSet('data', $comunicados));
        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }
}
